#region Using declarations
using System;
using System.IO;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Indicator;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Strategy;
#endregion

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    /// <summary>
    /// Enter the description of your strategy here
    /// </summary>
    [Description("Enter the description of your strategy here")]
    public class TEST01 : Strategy
    {
        #region Variables
        // Wizard generated variables
        private int myInput0 = 1; // Default setting for MyInput0
        // User defined variables (add any user defined variables below)
		private string outFile;
        #endregion

        /// <summary>
        /// This method is used to configure the strategy and is called once before any strategy method is called.
        /// </summary>
        protected override void Initialize()
        {
            CalculateOnBarClose = false;
			System.Threading.Thread.CurrentThread.CurrentCulture = new System.Globalization.CultureInfo("en-US");
			
			DateTime today = DateTime.Now;
			int currentYear = today.Year;
			int currentMonth = today.Month;
			int currentDay = today.Day;
			
			outFile = "F:\\Program Files (x86)\\TSLab 1.2\\Текстовики\\SP500_Futures\\SP500_Futures_" + currentYear.ToString() + ".";
			if( currentMonth < 10 )
				outFile = outFile + "0" + currentMonth.ToString() + ".";
			else
				outFile = outFile + currentMonth.ToString() + ".";
			
			if( currentDay < 10 )
				outFile = outFile + "0" + currentDay.ToString() + ".txt";
			else
				outFile = outFile + currentDay.ToString() + ".txt";
			
			StreamWriter sw = File.CreateText( outFile );
			string firstStr = "<DATE>,<TIME>,<MSEC>,<TRADENO>,<LAST>,<VOL>,<DIRECTION>,<ASK>,<BID>,<INTEREST>";
			sw.WriteLine( firstStr );
			sw.Flush();
			sw.Close();
        }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
        protected override void OnBarUpdate()
        {
			// Работаем только в режиме реального времени:
			if(Historical) return;
			
			string str;
			StreamWriter sw = new StreamWriter( outFile, true );
			DateTime now = DateTime.Now;
			
			double currentAsk = GetCurrentAsk();
			double currentBid = GetCurrentBid();
			double currentAskVolume = GetCurrentAskVolume();
			double currentBidVolume = GetCurrentBidVolume();
			double last = Close[0];
			
			str = now.Year.ToString();
			if( now.Month < 10 )
				str = str + "0" + now.Month.ToString();
			else
				str = str + now.Month.ToString();
			
			if( now.Day < 10 )
				str = str + "0" + now.Day.ToString() + ",";
			else
				str = str + now.Day.ToString() + ",";
			
			if( now.Hour < 10 )
				str = str + "0" + now.Hour.ToString();
			else
				str = str + now.Hour.ToString();
			
			if( now.Minute < 10 )
				str = str + "0" + now.Minute.ToString();
			else
				str = str + now.Minute.ToString();
			
			if( now.Second < 10 )
				str = str + "0" + now.Second.ToString() + ",";
			else
				str = str + now.Second.ToString() + ",";
			
			if( now.Millisecond < 10 )
				str = str + "00" + now.Millisecond.ToString() + ",";
			else if( 10 <= now.Millisecond && now.Millisecond < 100 )
				str = str + "0" + now.Millisecond.ToString() + ",";
			else
				str = str + now.Millisecond.ToString() + ",";
			
			str = str + "1," + last.ToString() + ",1,Sell," + currentAsk.ToString() + "," + currentBid.ToString() + ",1";
			//Print( str );
			
			sw.Flush();
			sw.WriteLine( str );
			
			sw.Close();
        }

        #region Properties
        [Description("")]
        [GridCategory("Parameters")]
        public int MyInput0
        {
            get { return myInput0; }
            set { myInput0 = Math.Max(1, value); }
        }
        #endregion
    }
}